<template>
  <div>
    <div>
      <v-card>
        <v-card-text class="headline">{{ formSurvey.survey_name }}</v-card-text>
      </v-card>
      <v-expansion-panels
        v-model="panel"
        multiple
        flat
      >
        <v-expansion-panel>
          <v-expansion-panel-header>Preview</v-expansion-panel-header>
          <v-expansion-panel-content>
            <v-card
              :disabled="disabled"
              class="detail-survey"
            >
              <v-card-title>
                {{ $t('label.purpose_survey') }}
              </v-card-title>
              <v-card-text>
                <html-binding-text :html="formSurvey.description" />
              </v-card-text>
            </v-card>
            <v-card
              :disabled="disabled"
              class="detail-survey"
            >
              <v-card-title>
                {{ $t('label.introduction_survey') }}
              </v-card-title>
              <v-card-text>
                <html-binding-text :html="formSurvey.introduction" />
              </v-card-text>
            </v-card>
          </v-expansion-panel-content>
        </v-expansion-panel>
      </v-expansion-panels>
    </div>
    <div class="questions-list">
      <v-card
        class="mx-auto"
      >
        <v-card-title>
          {{ $t('label.question') }}
        </v-card-title>
        <ValidationObserver v-slot="{ validate, reset }" ref="observer">
          <form
            ref="form"
          >
            <div v-if="addQuestion">
              <survey-questions-builder :questions-list="questionsList"/>
            </div>
            <div style="padding: 5px;" @click="addNewQuestion">
              <v-card
                class="mx-auto"
                style="padding: 30px;border: 1px dashed #E0E0E0;box-sizing: border-box;border-radius: 4px;"
              >
                <v-container
                  fill-height
                  fluid
                >
                  <v-row
                    align="center"
                    justify="center"
                  >
                    <div align="center">
                      <div>
                        <v-icon style="font-size: 48px;">mdi-plus-circle-outline</v-icon>
                      </div>
                      <div>{{ $t('label.add_question') }}</div>
                    </div>
                  </v-row>
                </v-container>
              </v-card>
            </div>
            <v-container fluid>
              <v-row class="survey-bottom-form">
                <v-col>
                  <v-btn
                    absolute
                    bottom
                    outlined
                    @click="backStep()"
                  >
                    {{ $t('label.back') }}
                  </v-btn>
                </v-col>
                <v-col>
                  <v-btn
                    :disabled="questionsList.length <= 0"
                    color="success"
                    bottom
                    style="float: right;"
                    @click="savePublishSurvey()"
                  >
                    {{ $t('label.save_and_publish') }}
                  </v-btn>
                  <v-btn
                    :disabled="questionsList.length <= 0"
                    color="success"
                    bottom
                    outlined
                    style="float: right;margin-right: 12px;"
                    @click="saveSurvey()"
                  >
                    {{ $t('label.survey_save') }}
                  </v-btn>
                </v-col>
              </v-row>
            </v-container>
          </form>
        </ValidationObserver>
      </v-card>
    </div>
    <modal-generate-link
      :dialog="dialog"
      :url="url_survey"
      :dialog-update.sync="dialog"
    />
    <loading-bar :loading="loading" />
  </div>
</template>

<script>

import { ValidationObserver } from 'vee-validate'
import EventBus from '@/utils/eventBus'
import { baseUrl } from '@/utils/constantVariable'

export default {
  name: 'SurveyFormQuestion',
  components: {
    ValidationObserver
  },
  props: {
    steps: {
      type: Number,
      default: null
    },
    formSurvey: {
      type: Object,
      default: null
    },
    questionsList: {
      type: Array,
      default: null
    }
  },
  data: () => ({
    panel: [0],
    dialog: false,
    loading: false,
    addQuestion: false,
    disabled: true,
    url_survey: ''
  }),
  mounted() {
    if (this.questionsList.length > 0) {
      this.addQuestion = true
    }
  },
  methods: {
    async saveSurvey() {
      const valid = await this.$refs.observer.validate()
      if (!valid) {
        return
      }
      const data = {
        id_survey: this.formSurvey.id,
        questions: this.questionsList

      }
      try {
        await this.$store.dispatch('survey/createQuestionsSurvey', data)
        await this.$store.dispatch('toast/successToast', this.$t('success.create_survey_success'))
        await this.$router.push('/survey/index')
      } catch (err) {
        await this.$store.dispatch('toast/errorToast', this.$t('errors.server_error_occurred'))
      }
    },
    async savePublishSurvey() {
      const valid = await this.$refs.observer.validate()
      if (!valid) {
        return
      }
      const data = {
        id_survey: this.formSurvey.id,
        questions: this.questionsList

      }
      try {
        Object.assign(this.formSurvey, { status: 'Active' })
        await this.$store.dispatch('survey/updateSurvey', this.formSurvey)
        this.loading = true
        const resp = await this.$store.dispatch('survey/createQuestionsSurvey', data)
        if (resp) {
          this.loading = false
        }
        this.url_survey = `${baseUrl()}/#/form/s/r?key=${this.formSurvey.url_survey_token}`
        this.dialog = true
      } catch (err) {
        await this.$store.dispatch('toast/errorToast', this.$t('errors.server_error_occurred'))
      }
    },
    backStep() {
      EventBus.$emit('backSurveySteps', this.steps)
    },
    addNewQuestion() {
      const data = {
        form_type: 'SHORTTEXT',
        sequence_questions: this.questionsList.length + 1,
        require: false,
        question: '',
        description: '',
        options: [
          {
            sequence: 1,
            body: ''
          }
        ]
      }
      this.$store.dispatch('survey/setQuestionSurvey', data)
      this.addQuestion = true
    }
  }
}
</script>
<style scoped>
.survey-bottom-form {
  padding-top: 50px;
}
.detail-survey {
  margin-bottom: 12px;
  background: #F2F2F2;
  box-shadow: 0px 1px 0px rgba(0, 0, 0, 0.25);
  border-radius: 8px 8px 0px 0px;
}
</style>
